﻿using Syncfusion.Windows.Forms.Tools;
using System;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;

namespace WF_TreeViewAdv
{
    public partial class Form1 : Form
    {
        TreeNodeAdv firstItem = null;
        public Form1()
        {
            InitializeComponent();
            //this.treeViewAdv1.EnableVirtualization = true;
            this.treeViewAdv1.SuspendExpandRecalculate = true;
            this.treeViewAdv1.RecalculateExpansion = false;
            this.treeViewAdv1.NodeMouseClick += TreeViewAdv1_NodeMouseClick;

            treeViewAdv1.Nodes.Add(firstItem = new TreeNodeAdv("Geometry"));
        }

        private void TreeViewAdv1_NodeMouseClick(object sender, TreeViewAdvMouseClickEventArgs e)
        {
            SelNodesPropagation(e.Node.Nodes, e.Node.Checked);
        }

        private void SelNodesPropagation(TreeNodeAdvCollection nd, bool bCheck)
        { 
            if ((nd == null))
                return;

            foreach (TreeNodeAdv nodX in nd)
            {
                nodX.Checked = bCheck;

                SelNodesPropagation(nodX.Nodes, bCheck);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Stopwatch sw = new Stopwatch();
            sw.Start();
            treeViewAdv1.LeftImageList = this.imageList1;
            firstItem.Expanded = true;
            int iMax = 10;
            for (int i = 1; i <= iMax; i++)
            {
                TreeNodeAdv treeNodeAdv = new TreeNodeAdv("BoxCornerExtent_1_" + i);
                for (int j = 1; j <=5 ; j++)
                {
                    TreeNodeAdv child = new TreeNodeAdv("Creation");
                    treeNodeAdv.Nodes.Add(child);
                    for (int k = 1; k <= 5; k++)
                    {
                        TreeNodeAdv child1 = new TreeNodeAdv("Creation1");
                        child.Nodes.Add(child1);
                        child1.LeftImageIndices = new int[] { 2 };
                    }

                    child.LeftImageIndices = new int[] { 2 };
                }
                firstItem.Nodes.Insert(i - 1, treeNodeAdv);
                treeNodeAdv.TextColor = Color.Blue;
                treeNodeAdv.Text = "Box_1_" + i;
                treeNodeAdv.SortOrder = SortOrder.Ascending;
                treeNodeAdv.LeftImageIndices = new int[] { 1, 0};
            }
            sw.Stop();
            //MessageBox.Show("Time = " + sw.ElapsedMilliseconds + " (ms) for " + iMax + " nodes");
        }
    }
}
